
import com.alibaba.fastjson.JSON;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONObject;


import java.io.*;

import java.util.ArrayList;
import java.util.List;

public class Main {

    public static void main(String[] args) throws IOException {

        String url = "http://119.29.254.99:8000/v1/chat/completions"; // 替换为文心一言的API地址

        CloseableHttpClient httpclient = HttpClients.createDefault();
        // 创建httppost
        HttpPost httppost = new HttpPost("http://119.29.254.99:8000/v1/chat/completions");
        httppost.addHeader("Authorization","Bearer eyJhbGciOiJIUzUxMiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJ1c2VyLWNlbnRlciIsImV4cCI6MTcyNDY3NjM1MiwiaWF0IjoxNzE2OTAwMzUyLCJqdGkiOiJjcGF0NDA1dmJmNnRwNG0wdGUyMCIsInR5cCI6InJlZnJlc2giLCJzdWIiOiJjcGF0NDA1dmJmNnRwNG0wdGR2ZyIsInNwYWNlX2lkIjoiY3BhdDQwNXZiZjZ0cDRtMHRkdjAiLCJhYnN0cmFjdF91c2VyX2lkIjoiY3BhdDQwNXZiZjZ0cDRtMHRkdWcifQ.irkXZJ3vcVi9pk4gVYOcaKab7nhxXCkclpjOFEf1nLTou06z3LoNefUGCBsZ5XAiip5Zh8HbRgZJGzLk08cc6A");
        httppost.setHeader("Content-Type","application/json");
        // 创建参数队列

        JSONArray jsonArray=new JSONArray();
        JSONObject jsonObject=new JSONObject();
        jsonObject.put("role","user");
        jsonObject.put("content","给我写一段python爬虫");
        jsonArray.put(jsonObject);
        JSONObject object=new JSONObject();
        object.put("model","kimi");
        object.put("use_search",true);
        object.put("stream",false);
        object.put("messages",jsonArray);

        StringEntity uefEntity;
        try {
            uefEntity = new StringEntity(object.toString(), "UTF-8");
            httppost.setEntity(uefEntity);

            System.out.println("executing request " + httppost.getURI());
            System.out.println(httppost);
            CloseableHttpResponse response = httpclient.execute(httppost);
            try {
                HttpEntity entity = response.getEntity();

                if (entity != null) {

                    String responseString = EntityUtils.toString(entity, "UTF-8");
                    System.out.println(responseString);
                    ObjectMapper mapper = new ObjectMapper();
                    Response response1 = mapper.readValue(responseString, Response.class);
                    System.out.println(response1+"\n\n\n\n\n\n\n");
                    JsonNode jsonNode = mapper.readTree(responseString);
                    System.out.println(jsonNode);

//                    JSONObject jsonObject1=new JSONObject(responseString);
//                    System.out.println(jsonObject1);
                    System.out.println("--------------------------------------");
                    System.out.println("Response content: " + responseString);

                    System.out.println("--------------------------------------");
                }
            } finally {
                response.close();
            }
        } catch (ClientProtocolException e) {
            e.printStackTrace();
        } catch (UnsupportedEncodingException e1) {
            e1.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            // 关闭连接,释放资源
            try {
                httpclient.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }


//        URL obj = new URL(url);
//        HttpURLConnection con = (HttpURLConnection) obj.openConnection();
//
//        // 设置请求方法为POST
//        con.setRequestMethod("POST");
//        con.setRequestProperty("Authorization","Bearer eyJhbGciOiJIUzUxMiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJ1c2VyLWNlbnRlciIsImV4cCI6MTcxNjg5NTEzNiwiaWF0IjoxNzE2ODk0MjM2LCJqdGkiOiJjcGFyazc2NzY4ajVhNGxjMjZlMCIsInR5cCI6ImFjY2VzcyIsInN1YiI6ImNwYXJrNzY3NjhqNWE0bGMyNmRnIiwic3BhY2VfaWQiOiJjcGFyazc2NzY4ajVhNGxjMjZkMCIsImFic3RyYWN0X3VzZXJfaWQiOiJjcGFyazc2NzY4ajVhNGxjMjZjZyJ9.HfujoeHNgRZia4oIsH2DhEzQCLsloKFjAu_BItOdDz7AJek-rT8Fn2t2BjWAPRtA97oBCMMNkcZkCeTx8A2UYg");
//        con.setRequestProperty("Content-Type", "application/json; utf-8");
//        // 发送POST请求必须设置如下两行
//        con.setDoOutput(true);
//        con.setDoInput(true);
//        // 创建JSON对象
//        JSONObject jsonObject = new JSONObject();
//
//        // 添加模型名称
//        jsonObject.put("model", "kimi");
//        // 创建消息数组
//        JSONArray messages = new JSONArray();
//
//        // 创建一个消息
//        JSONObject message = new JSONObject();
//        message.put("role", "user");
//        message.put("content", "测试");
//
//        // 将消息添加到消息数组
//        messages.set(0,message);
//
//        // 将消息数组添加到主对象
//        jsonObject.put("messages", messages);
//        System.out.println(messages);
//
//        // 添加其他属性
//        jsonObject.put("use_search", true);
//        jsonObject.put("stream", false);
//        System.out.println(jsonObject);
//        // 添加请求体
//
//        try(OutputStream os = con.getOutputStream()) {
//            byte[] input = jsonObject.toJSONString().getBytes("utf-8");
//            os.write(input, 0, input.length);
//        }
//        System.out.println(con.getRequestProperty("body.messages"));
//        int responseCode = con.getResponseCode();
//        System.out.println("Response Code : " + responseCode);
//
//        BufferedReader in = new BufferedReader(
//                new InputStreamReader(con.getInputStream()));
//        String inputLine;
//        StringBuffer response = new StringBuffer();
//
//        while ((inputLine = in.readLine()) != null) {
//            response.append(inputLine);
//        }
//        in.close();
//
//        // 打印结果
//        System.out.println(response.toString());
    }

}
